#include "enemigo.h"
#include "enemy.h"
#include "nivel.h"
#include "tablas.h"

const TFrame g_eframes[ENEMY_FRAMES] = {
      { M_derecha, g_enemy_00 }   ,  { M_derecha, g_enemy_01 }
   ,  { M_derecha, g_enemy_02 }   ,  { M_derecha, g_enemy_03 }
   ,  { M_derecha, g_enemy_04 }   ,  { M_derecha, g_enemy_05 }
   ,  { M_derecha, g_enemy_06 }   ,  { M_derecha, g_enemy_07 }
   ,  { M_derecha, g_enemy_08 }   ,  { M_derecha, g_enemy_09 }
   ,  { M_derecha, g_enemy_10 }   ,  { M_derecha, g_enemy_11 }
   ,  { M_derecha, g_enemy_12 }   ,  { M_derecha, g_enemy_13 }
   ,  { M_derecha, g_enemy_14 }   ,  { M_derecha, g_enemy_15 }
};

const TPos g_enempos[MAX_ENEMIGOS] = {
   { { 44, 44, 44 }, { 80, 80, 80 }, 1 },
   { { 8, 8, 8 }, {108, 108, 108 }, 0 },
   { { 8, 8, 8 },  { 108, 108, 108 }, 2}
};

TFrame* const anim_eandar[ANDAR_FRAMES] = { 
   &g_eframes[1], &g_eframes[2], &g_eframes[3], &g_eframes[4], &g_eframes[5]
};
TFrame* const anim_esaltar[SALTAR_FRAMES] = { 
   &g_eframes[8], &g_eframes[9], &g_eframes[10], &g_eframes[11]
};
TFrame* const anim_ecaer[CAER_FRAMES] = { 
   &g_eframes[14], &g_eframes[15]
};

TEntidad enemigos[MAX_ENEMIGOS];
void comprobarNodo(TEntidad* e)
{
    u8 intermedio= Route1[e->pos.num_mapa][e->nodoActual-1][e->nodoFuturo-1][0]-1;
    u8 exmax,exmin,nxmax,nxmin,eymax,eymin,nymax,nymin;
    nxmin=Nodos[e->pos.num_mapa][intermedio][0];
    nxmax=nxmin+4;
    nymin=Nodos[e->pos.num_mapa][intermedio][1];
    nymax=nymin+8;

    exmin=e->pos.x[0];
    exmax=exmin+6;
    eymin=e->pos.y[0];
    eymax=eymin+18;

  if(((nxmin>exmin && nxmax<exmax)&&(nymin>eymin && nymax<eymax)) || ((nxmin>exmin && nxmin<exmax)&&(nymin>eymin && nymin<eymax))){
     e->nodoActual=intermedio+1;
     e->forzarAndar=0;
  }
}
void dondeMover(TEntidad* e)
{
  if(e->pos.num_mapa==2)
  {
     if(e->nodoActual==e->nodoFuturo && e->nodoActual==1)
      e->nodoFuturo=9;
      if(e->nodoActual==e->nodoFuturo && e->nodoActual==9)
      e->nodoFuturo=1;
  }
  else if(e->pos.num_mapa==0)
  {
     
      if(e->nodoActual==e->nodoFuturo && e->nodoActual==3)
      e->nodoFuturo=8;
  }
}

void moverEnemigos(){

  u8 i = 1;
  u8 max = level.num_enem;
  TEntidad *enem;
  while(i <= max ){
     enem = enemigos + i-1;
    if(i!=1){
      comprobarNodo(enem);
      dondeMover(enem);
      ejecutarEstado(enem);

      if (entidad.pos.num_mapa == enem->pos.num_mapa) {
          if(enem->mover) {
            seleccionarSpriteEntidad(enem);

            if(enem->draw){
               borrarEntidad(enem);
               dibujarEntidad(enem);
               entityDrawnUpdate(enem);               
            }
            enem->mover = NO;
         }
      }
    }
    else{
        if (entidad.pos.num_mapa == enem->pos.num_mapa) {
        dibujarEntidad(enem);
      }
    }      
      ++i;
   }
}


u8 comprobarMovimientoEnemigo(TEntidad* e)
{   
    
    u8 actu=e->nodoActual-1,intermedio=Route1[e->pos.num_mapa][e->nodoActual-1][e->nodoFuturo-1][0]-1;
    u8 accion=Route1[e->pos.num_mapa][actu][intermedio][1];
    if(entidad.pos.num_mapa == e->pos.num_mapa && actu!=intermedio && e->forzarAndar==0)
    {
      return accion;
    }
    return -1;
   
}
u8 comprobarSalto(TEntidad* e)
{   
    u8 ey,nFy;
    u8 actu=e->nodoActual-1,intermedio= Route1[e->pos.num_mapa][e->nodoActual-1][e->nodoFuturo-1][0]-1;
    u8 accion=Route1[e->pos.num_mapa][actu][intermedio][2];
    ey = e->pos.y[0];
    nFy=Nodos[e->pos.num_mapa][intermedio][1];

    if(entidad.pos.num_mapa == e->pos.num_mapa && actu!=intermedio)
    { 
      if( ey-nFy<=0)
        return accion;
    }
    if(e->forzarAndar==1)
    {
      return accion;
    }
    return -1;
   
}