#include "mapa.h"
#include "hero.h"
#include "objeto.h"
#include "enemigo.h"
#include "nivel.h"
#include "juego.h"

u8* const mapas[] = { g_map3, g_map4, g_map2, g_map1 };

void debug() {}
void dummy_initializers() __naked {
__asm
   _g_backBuffer::      .dw 0x8000
   _g_screenMem::       .dw 0xC000

__endasm;
}

void dibujarMapa() {
	u8* pvmem = cpct_getScreenPtr(g_backBuffer,0,40);
	cpct_etm_drawTilemap2x4_f(g_map1_W, g_map1_H, pvmem, mapas[entidad.pos.num_mapa]);
}

void dibujarMapa_initial() {
	u8* pvmem = cpct_getScreenPtr(g_screenMem,0,40);
	cpct_etm_drawTilemap2x4_f(g_map1_W, g_map1_H, pvmem, mapas[entidad.pos.num_mapa]);
}

void switchBuffers() {
   u8* aux = g_backBuffer;
   g_backBuffer = g_screenMem;
   g_screenMem = aux;
   cpct_setVideoMemoryPage( ((u16)g_screenMem) >> 10);
}

u8* obtenerTilePtr(u8 x, u8 y) {
	return mapas[entidad.pos.num_mapa] + (y-ORIGEN_MAPA_Y)/4*g_map1_W + x/2;
}

u8 sobreSuelo(TEntidad* e) {
	u8* tileSuelo = obtenerTilePtr(e->pos.x[0], e->pos.y[0] + ALTO_HERO+1);

	if (*tileSuelo !=29 || *(tileSuelo+G_HERO_00_W/2-1) !=29)
		return 1;
	return 0;
}

u8 esFondo(u8* tile) {

	if (*tile ==29 || *tile ==18|| *tile ==19|| *tile ==20|| *tile ==24|| *tile ==25|| *tile ==26) {
		return 1;
	}   
	return 0;
}
u8 colisionEnemigo() {
	 u8 i = 0;
   u8 max = level.num_enem;
   u8 bxmax,bxmin,mxmax,mxmin,bymax,bymin,mymax,mymin;
   while(i < max) {
      TEntidad *enem = enemigos + i;
      if(entidad.pos.num_mapa == enem->pos.num_mapa){
        bxmax=enem->pos.x[0]+5;
		bxmin=enem->pos.x[0];
		bymax=enem->pos.y[0]+19;
		bymin=enem->pos.y[0];
		mxmin=entidad.pos.x[0];
		mxmax=mxmin+6;
		mymin=entidad.pos.y[0];
		mymax=mymin+19;
		if(((bxmax>=mxmin && bxmax<=mxmax)&&(bymax>=mymin && bymax<=mymax)) || ((bxmin>=mxmin && bxmin<=mxmax)&&(bymin>=mymin && bymin<=mymax))){
			return 1;
		}
      }
      ++i;
   }
	return 0;
}

u8 comprobarPared(TEntidad* e,u8 lado) {
	u8 i=5;
	if(colisionEnemigo())
	{
		muerteCaida(&entidad);	
	}
	while(i<15) {
		if (!esFondo(obtenerTilePtr(e->pos.x[0]+6, e->pos.y[0]+i)) && lado)
			return 1;
		else if (!esFondo(obtenerTilePtr(e->pos.x[0]-1, e->pos.y[0]+i)) && !lado && e->pos.x[0]>3)
			return 1;
		++i;++i;++i;++i;
	}

	return 0;
}

u8 comprobarPosBanana() {
	u8 bxmax,bxmin,mxmax,mxmin,bymax,bymin,mymax,mymin;
	bxmax=banana.pos[2].x+1;
	bxmin=banana.pos[0].x;
	bymax=banana.pos[2].y+4;
	bymin=banana.pos[0].y;
	mxmin=entidad.pos.x[0];
	mxmax=mxmin+6;
	mymin=entidad.pos.y[0];
	mymax=mymin+18;

	if(((bxmax>=mxmin && bxmax<=mxmax)&&(bymax>=mymin && bymax<=mymax)) || ((bxmin>=mxmin && bxmin<=mxmax)&&(bymin>=mymin && bymin<=mymax))){
		return 1;
	}
	return 0;
}

u8 comprobarPosVida() {
	u8 bxmax,bxmin,mxmax,mxmin,bymax,bymin,mymax,mymin;
	bxmax=vida.pos[1].x+1;
	bxmin=vida.pos[0].x;
	bymax=vida.pos[1].y+4;
	bymin=vida.pos[0].y;
	mxmin=entidad.pos.x[0];
	mxmax=mxmin+6;
	mymin=entidad.pos.y[0];
	mymax=mymin+18;

	if(((bxmax>=mxmin && bxmax<=mxmax)&&(bymax>=mymin && bymax<=mymax)) || ((bxmin>=mxmin && bxmin<=mxmax)&&(bymin>=mymin && bymin<=mymax))){
		return 1;
	}
	return 0;
}

u8 colisionLateral(u8 y){
	u8 aux = y+19;

	if(entidad.pos.y[0] == aux) {
		return 1;
	}
	
	return 0;
}

u8 colisionVertical(u8 x) {
	u8 aux = x+6;

	if(entidad.pos.x[0] >= x &&  entidad.pos.x[0] <= aux) {
		return 1;
	}

	return 0;
}

void avanzarMapa() {
	if (entidad.pos.num_mapa == 0 || entidad.pos.num_mapa == 2) {
		++entidad.pos.num_mapa;
		desplazarEntidad(&entidad, 0, 0, entidad.pos.y[0]);
		dibujarMapa_initial();
		dibujarMapa();
		dibujarBanana();
    	dibujarVida();
	}
}

void retrocederMapa() {
	if (entidad.pos.num_mapa == 1 || entidad.pos.num_mapa == 3) {
		--entidad.pos.num_mapa;
		desplazarEntidad(&entidad, 0, ANCHO_PANTALLA- ANCHO_HERO, entidad.pos.y[0]);
		dibujarMapa_initial();
		dibujarMapa();
		dibujarBanana();
    	dibujarVida();
	}
}

void subirMapa() {
	if (entidad.pos.num_mapa == 2) {
		--entidad.pos.num_mapa;--entidad.pos.num_mapa;
		desplazarEntidad(&entidad, 0, entidad.pos.x[0], 190- ALTO_HERO);
		dibujarMapa_initial();
		dibujarMapa();
		dibujarBanana();
    	dibujarVida();
	}
}

void bajarMapa() {
	++entidad.pos.num_mapa;++entidad.pos.num_mapa;
	desplazarEntidad(&entidad, 0, entidad.pos.x[0], ORIGEN_MAPA_Y+2);
	dibujarMapa_initial();
	dibujarMapa();
	dibujarBanana();
    dibujarVida();	
}

u8 bordeInferior(TEntidad* e){
	if(e->pos.y[0]+ALTO_HERO>199) {
		return 1;
	}
	return 0;
}

void muerteCaida(TEntidad* e){
	
	if(e->nbanana[0]=='e') {
		reiniciarEnemigo(e);
	}
	else{
		if(e->nvida[0]<'2' )
		{
			reset=0;
			gameOver();			
		}
		else{
			--e->nvida[0];
			inicializarEntidad(entidad.nvida[0]);
			dibujarMapa_initial();
			dibujarMapa();
			dibujarEntidad_initial(&entidad);
			dibujarEntidad(&entidad);
			dibujarBanana();
			pintarContadores();
		}	

	}
	
}