#include "objeto.h"
#include "tiles.h"
#include "entidad.h"
#include "mapa.h"
#include "nivel.h"
#include "juego.h"
#include "nivel.h"

const TBanana g_bananapos[NUM_BANANAS] = {
	{ { {g_tiles_00, 60, 72}, {g_tiles_01, 60, 76}, {g_tiles_02, 62, 76} }, 3 },
	{ { {g_tiles_00, 38, 96}, {g_tiles_01, 38, 100}, {g_tiles_02, 40, 100}}, 3 },
	{ { {g_tiles_00, 38, 104}, {g_tiles_01, 38, 108}, {g_tiles_02, 40, 108} }, 2 },
	{ { {g_tiles_00, 4, 72}, {g_tiles_01, 4, 76}, {g_tiles_02, 6, 76} }, 2 },
	{ { {g_tiles_00, 18, 64}, {g_tiles_01, 18, 68}, {g_tiles_02, 20, 68} }, 0 },
	{ { {g_tiles_00, 48, 136}, {g_tiles_01, 48, 140}, {g_tiles_02, 50, 140} }, 0 },
	{ { {g_tiles_00, 12, 84}, {g_tiles_01, 12, 88}, {g_tiles_02, 14, 88} }, 1 },
	{ { {g_tiles_00, 76, 60}, {g_tiles_01, 76, 64}, {g_tiles_02, 78, 64} }, 1 }
};

const TVida g_vidapos[NUM_VIDAS] = {
	{ { {g_tiles_06, 36, 84}, {g_tiles_12, 38, 84} }, 0},
	{ { {g_tiles_06, 74, 180}, {g_tiles_12, 76, 180} }, 1}
};

TBanana banana;
TVida vida;


void dibujarTile(void* tile, u8 x, u8 y) {
   u8* pvmem = cpct_getScreenPtr(g_backBuffer,x,y);
   u8* pvmemm = cpct_getScreenPtr(g_screenMem,x,y);
   cpct_drawSpriteMaskedAlignedTable (tile,pvmem,2,4, g_tablatrans);
   cpct_drawSpriteMaskedAlignedTable (tile,pvmemm,2,4, g_tablatrans);
}

void borrarTile(u8 x, u8 y, u8 w, u8 h) {
	u8* pvmem= cpct_getScreenPtr(g_backBuffer,0,40);
	u8* pvmemm = cpct_getScreenPtr(g_screenMem,0,40);
	cpct_etm_drawTileBox2x4(x/2, (y-40)/4, w, h, 40, pvmem, mapas[banana.num_mapa]);
	cpct_etm_drawTileBox2x4(x/2, (y-40)/4, w, h, 40, pvmemm, mapas[banana.num_mapa]);
}

void dibujarBanana(){
	if(entidad.pos.num_mapa == banana.num_mapa){
		u8 i = 4;
		while(--i){
			dibujarTile(banana.pos[i-1].tile, banana.pos[i-1].x, banana.pos[i-1].y);
		}
	}
}

void dibujarVida(){
	if(entidad.pos.num_mapa == vida.num_mapa){
		u8 i = 3;

		while(--i){
			dibujarTile(vida.pos[i-1].tile, vida.pos[i-1].x, vida.pos[i-1].y);
		}
	}
}

void borrarBanana() {
	borrarTile(banana.pos[0].x, banana.pos[0].y, 2, 4);
}

void borrarVida() {
	borrarTile(vida.pos[0].x, vida.pos[0].y, 2, 2);
}

void cogerBanana() {
	u8 c,mod,seed;
	if(entidad.pos.num_mapa == banana.num_mapa){
		if(comprobarPosBanana()){
			borrarBanana();
			if(++itemBanana>=8){
				itemBanana = 0;
			} else {
				++itemBanana;
			}
			inicializarBanana(itemBanana);
			if(entidad.nbanana[1] == '9') {
				++entidad.nbanana[0];
				entidad.nbanana[1] = '0';
			} else {
				++entidad.nbanana[1];
			}
			pintarContadores();
			dibujarBanana();
		}
	}
}



void cogerVida() {
	if(entidad.pos.num_mapa == vida.num_mapa){
		if(comprobarPosVida()){
			if(entidad.nvida[0]<'3')
			{
				++entidad.nvida[0];
			}
			borrarVida();
			if(itemVida>=2){
				itemVida = 1;
			} else {
				++itemVida;
			}
			inicializarVida(itemVida);
			pintarContadores();
			dibujarVida();
		}
	}
}