#ifndef __OBJETO_H__
#define __OBJETO_H__

#include <types.h>

#define NUM_BANANAS	8
#define NUM_VIDAS	2

typedef struct TilePos {
	void* tile;
	u8 x, y;
} TTilePos;

typedef struct Banana {
	TTilePos pos[3];
	u8 num_mapa;
} TBanana;

typedef struct Vida {
	TTilePos pos[2];
	u8 num_mapa;
} TVida;

extern const TBanana g_bananapos[NUM_BANANAS];
extern const TVida g_vidapos[NUM_VIDAS];

extern TBanana banana;
extern TVida vida;

void dibujarTile(void* tile, u8 x, u8 y);
void borrarTile(u8 x, u8 y, u8 w, u8 h);
void dibujarBanana();
void dibujarVida();
void borrarBanana();
void cogerBanana();
void cogerVida();

#endif